<ng-container *subscribe="updateIndicatorDataMutation.result$ as indicatorData">
  <ngx-loading [show]="indicatorData.isLoading" />
</ng-container>

<div [ngClass]="['e-walidata-list-indicator']">
  <div [ngClass]="['table-wrapper', jds.tablePaging]">
    <table
      [ngClass]="[jds.table, jds.mb(0)]"
      role="table"
      aria-label="List Monitor Indicator"
      aria-describedby="Table List Monitor Indicator"
      stickyTable
    >
      <thead
        [ngClass]="[jds.bg(jdsBiColor.gray['100'])]"
        [style.verticalAlign]="'middle'"
      >
        <tr>
          <th
            [ngClass]="[jds.minW(66)]"
            [style.zIndex]="20"
            stickyColumn
          >
            No
          </th>
          <th
            [ngClass]="[jds.minW(130)]"
            [style.zIndex]="20"
            stickyColumn
          >
            Kode DSSD
          </th>
          <th
            [ngClass]="[jds.minW(400)]"
            [style.zIndex]="20"
            stickyColumn
          >
            Uraian
          </th>
          <th
            [ngClass]="[
              jds.minW(260),
              satudataUser.role_name === 'walidata'
                ? jds.d('block')
                : jds.d('none')
            ]"
            [style.zIndex]="20"
            [colorScheme]="'gray'"
            [isFilterable]="satudataUser.role_name === 'walidata'"
            jdsBiTableHead
            scope="col"
            column="kode_skpd"
            stickyColumn
          >
            <span>OPD</span>
            <div
              [style.cursor]="'pointer'"
              (click)="onOpenFilterOrganization()"
              filter
              role="button"
            >
              <jds-bi-hosted-dropdown
                [(open)]="isOpenOrganization"
                [jdsBiDropdownLimitWidth]="'custom'"
                [jdsBiDropdownMinWidth]="400"
                [jdsBiDropdownAlign]="'right'"
                [content]="dropdownOrganization"
              >
                <i
                  class="tblhd-icon"
                  [ngClass]="['active']"
                ></i>
              </jds-bi-hosted-dropdown>
            </div>
          </th>
          <th
            [ngClass]="[jds.minW(100)]"
            [style.zIndex]="20"
            stickyColumn
          >
            Satuan
          </th>
          <ng-container *ngTemplateOutlet="tableHeadDynamic" />
        </tr>
      </thead>
      <tbody>
        <ng-container *ngIf="listIndicator as list">
          <ng-container *ngIf="list.status === 'loading'">
            <ng-container *ngTemplateOutlet="loadingTableBody" />
          </ng-container>

          <ng-container *ngIf="list.status === 'success'">
            <ng-container *ngIf="list.isFetching">
              <ng-container *ngTemplateOutlet="loadingTableBody" />
            </ng-container>

            <ng-container *ngIf="!list.isFetching">
              <ng-container *ngIf="list.data.list.length > 0">
                <tr *ngFor="let row of list.data.list; let i = index">
                  <td
                    [ngClass]="[jds.minW(66)]"
                    stickyColumn
                  >
                    {{
                      filterPerPageData * (filterCurrentPageData - 1) + (i + 1)
                    }}
                  </td>
                  <td
                    [ngClass]="[jds.minW(130)]"
                    stickyColumn
                  >
                    {{ row.kode_indikator }}
                  </td>
                  <td
                    [ngClass]="[jds.minW(400)]"
                    stickyColumn
                  >
                    {{ row.nama_indikator }}
                  </td>
                  <td
                    *ngIf="satudataUser.role_name === 'walidata'"
                    [ngClass]="[jds.minW(260)]"
                    stickyColumn
                  >
                    {{ row.nama_skpd || '-' }}
                  </td>
                  <td
                    [ngClass]="[jds.minW(100)]"
                    stickyColumn
                  >
                    {{ row.satuan }}
                  </td>
                  <ng-container
                    *ngFor="
                      let item of listIndicatorYear;
                      let j = index;
                      let c = count
                    "
                  >
                    <td
                      #tableData
                      *ngIf="getYearData(row.ewalidata_data, item) as ewalidata"
                      [ngClass]="[
                        jds.w(130),
                        jds.textAlign('right'),
                        ewalidata.verification
                          ? jds.bg(jdsBiColor.green['50'])
                          : ''
                      ]"
                      [style.zIndex]="10"
                      (click)="onClickData(ewalidata, i, j, c)"
                    >
                      <div #contentData>
                        {{ ewalidata.data | number : '1.0-0' : 'id' }}
                      </div>
                      <input
                        #inputData
                        *ngIf="satudataUser.role_name === 'opd'"
                        [style.display]="'none'"
                        [ngClass]="[
                          jds.border(0),
                          jds.rounded(0),
                          jds.textAlign('end')
                        ]"
                        [colorScheme]="colorScheme"
                        (blur)="
                          onBlurData(
                            {
                              pemda: ewalidata.pemda,
                              code: row.kode_indikator,
                              value: inputData.value,
                              year: ewalidata.year
                            },
                            i,
                            j,
                            c
                          )
                        "
                        type="text"
                        mask="separator"
                        thousandSeparator="."
                        jdsBiInput
                      />
                    </td>
                  </ng-container>
                </tr>
              </ng-container>

              <ng-container *ngIf="list.data.list.length === 0">
                <ng-container *ngTemplateOutlet="emptyTableBody" />
              </ng-container>
            </ng-container>
          </ng-container>
        </ng-container>
      </tbody>
    </table>
  </div>

  <ng-container *ngIf="listIndicator as list">
    <ng-container *ngIf="list.status === 'success'">
      <ng-container *ngIf="list.data.list.length > 0">
        <jds-bi-pagination
          [colorScheme]="colorScheme"
          [perPageItems]="perPageItems"
          [pagination]="list.data.pagination"
          [perPage]="filterPerPageData"
          [page]="filterCurrentPageData"
          (filterPerPage)="onPerPage($event)"
          (filterPage)="onPage($event)"
        />
      </ng-container>
    </ng-container>
  </ng-container>
</div>

<ng-template #dropdownOrganization>
  <div [ngClass]="[jds.px(16), jds.pt(12), jds.pb(8)]">
    <ng-container *ngIf="listOrganization as listOrganizationSatuData">
      <ng-container *ngIf="listOrganizationSatuData.status === 'loading'">
        <ng-container *ngTemplateOutlet="loadingOrganization" />
      </ng-container>

      <ng-container *ngIf="listOrganizationSatuData.status === 'success'">
        <ng-container *ngIf="listOrganizationSatuData.isFetching">
          <ng-container *ngTemplateOutlet="loadingOrganization" />
        </ng-container>

        <ng-container *ngIf="!listOrganizationSatuData.isFetching">
          <ul
            [ngClass]="[jds.ps(0), jds.mb(0)]"
            [style.listStyle]="'none'"
            [style.height]="'auto'"
          >
            <li
              *ngFor="let item of listOrganizationSatuData.data.list"
              [ngClass]="[jds.mb(5), jds.pe(15)]"
            >
              <div [ngClass]="[jds.formCheck]">
                <input
                  id="checkbox-organization-{{ item.id }}"
                  [(ngModel)]="item.checked"
                  [ngClass]="[jds.formCheckInput]"
                  (change)="
                    onFilterOrganization(item.kode_skpd, $event.target.checked)
                  "
                  type="checkbox"
                />
                <label
                  [ngClass]="[jds.formCheckLabel]"
                  for="checkbox-organization-{{ item.id }}"
                >
                  {{ item.nama_skpd }}
                </label>
              </div>
            </li>
          </ul>
        </ng-container>
      </ng-container>
    </ng-container>
  </div>
</ng-template>

<ng-template #loadingOrganization>
  <ng-container *ngFor="let i of [50, 75, 25]">
    <ngx-skeleton-loader
      [theme]="{
        width: i + '%',
        'border-radius': '0',
        height: '20px',
        'margin-bottom': '5px'
      }"
    />
  </ng-container>
</ng-template>

<ng-template #tableHeadDynamic>
  <ng-container *ngIf="listIndicator as list">
    <ng-container *ngIf="list.status === 'loading'">
      <ng-container *ngTemplateOutlet="loadingTableHeadDynamic" />
    </ng-container>

    <ng-container *ngIf="list.status === 'success'">
      <ng-container *ngIf="list.isFetching">
        <ng-container *ngTemplateOutlet="loadingTableHeadDynamic" />
      </ng-container>

      <ng-container *ngIf="!list.isFetching">
        <ng-container *ngIf="list.data.list.length > 0">
          <th
            *ngFor="let item of listIndicatorYear; let i = index"
            [ngClass]="[jds.minW(130), jds.textAlign('right')]"
            [style.zIndex]="10"
          >
            {{ item }}
          </th>
        </ng-container>

        <ng-container *ngIf="list.data.list.length === 0">
          <ng-container *ngTemplateOutlet="emptyTableHeadDynamic" />
        </ng-container>
      </ng-container>
    </ng-container>
  </ng-container>
</ng-template>

<ng-template #loadingTableHeadDynamic>
  <th
    *ngFor="let item of [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]"
    [ngClass]="[jds.minW(130)]"
    [style.zIndex]="10"
  >
    <ngx-skeleton-loader
      [theme]="{
        width: '90%',
        'border-radius': '0',
        height: '20px',
        'margin-bottom': '0'
      }"
    />
  </th>
</ng-template>

<ng-template #emptyTableHeadDynamic>
  <th
    [ngClass]="[jds.minW(130)]"
    [style.zIndex]="10"
  >
    Tidak ada data.
  </th>
</ng-template>

<ng-template #loadingTableBody>
  <tr *ngFor="let i of [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]">
    <td
      *ngFor="
        let j of satudataUser.role_name === 'walidata'
          ? [66, 130, 400, 260, 100]
          : [66, 130, 400, 100]
      "
      [style.minWidth.%]="j"
      stickyColumn
    >
      <div class="wrapper-skeleton">
        <ngx-skeleton-loader
          [theme]="{
            width: '80%',
            'border-radius': '0',
            height: '22px',
            'margin-bottom': '0px'
          }"
        />
      </div>
    </td>
    <td
      *ngFor="let item of [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]"
      [ngClass]="[jds.minW(130)]"
      [style.zIndex]="10"
    >
      <ngx-skeleton-loader
        [theme]="{
          width: '80%',
          'border-radius': '0',
          height: '22px',
          'margin-bottom': '0'
        }"
      />
    </td>
  </tr>
</ng-template>

<ng-template #emptyTableBody>
  <td
    [style.zIndex]="10"
    [style.width.%]="100"
    [attr.colspan]="satudataUser.role_name === 'walidata' ? 6 : 5"
    [ngClass]="[jds.textAlign('center')]"
  >
    Tidak ada data.
  </td>
</ng-template>
